## iitii 0.0+git20191030.85209e0

=== CMakeLists.txt ===
# Specify the minimum version for CMake

cmake_minimum_required(VERSION 3.1)

# Project's name
project(iitii)
# We build using c++14
set(CMAKE_CXX_STANDARD 14)

# Use all standard-compliant optimizations
set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O3 -g")
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -g")

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

  # assumes clang build
  # we can't reliably detect when we're using clang, so for the time being we assume
  # TODO: can't we though?
  
  # adapted from https://stackoverflow.com/questions/46414660/macos-cmake-and-openmp
  # find_package(OpenMP) does not work reliably on macOS, so we do its work ourselves
  set (OpenMP_C "${CMAKE_C_COMPILER}")
  set (OpenMP_C_FLAGS " -Xpreprocessor -fopenmp -I/opt/local/include/libomp -I/usr/local/include -L/opt/local/lib/libomp -L/usr/local/lib")
  set (OpenMP_C_LIB_NAMES "libomp" "libgomp" "libiomp5")
  set (OpenMP_CXX "${CMAKE_CXX_COMPILER}")
  set (OpenMP_CXX_FLAGS " -Xpreprocessor -fopenmp -I/opt/local/include/libomp -I/usr/local/include -L/opt/local/lib/libomp -L/usr/local/lib")
  set (OpenMP_CXX_LIB_NAMES "libomp" "libgomp" "libiomp5")
  set (OpenMP_libomp_LIBRARY "omp")
  set (OpenMP_libgomp_LIBRARY "gomp")
  set (OpenMP_libiomp5_LIBRARY "iomp5")
  
  # and now add the OpenMP parameters to the compile flags
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS} -lomp")
  
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

  find_package(OpenMP REQUIRED)
  
  # add the flags it detects to the compile flags
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS} -fopenmp")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} -fopenmp")
  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
  
endif()

# Set the output folder where your program will be created
set(CMAKE_BINARY_DIR ${CMAKE_SOURCE_DIR}/bin)
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
set(LIBRARY_OUTPUT_PATH ${CMAKE_SOURCE_DIR}/lib)

# The following folder will be included
include_directories("${PROJECT_SOURCE_DIR}")

# Add external projects
include(${CMAKE_ROOT}/Modules/ExternalProject.cmake)

# TODO: We're using INSTALL_DIR very wrong. We *should* be actually installing
# the external projects into their prefixes and working with the installed
# files. Instead we're building but not installing them and trying to work with
# the non-installed build trees.
# 
# Hence the blanked out INSTALL_COMMANDs to suppress the install step.
#
# We need to NOT blank out UPDATE_COMMAND or we can never change the Git revision we point to.
# The cost of this is that we have to re-configure on every build if we do update.

# In-place Parallel Super Scalar Samplesort (IPS⁴o), header only
ExternalProject_Add(ips4o
  GIT_REPOSITORY "https://github.com/vgteam/ips4o.git"
  GIT_TAG "22069381cc1bf2df07ee1ff47f6b6073fcfb4508"
  UPDATE_COMMAND ""
  INSTALL_COMMAND ""
  BUILD_COMMAND ""
  CONFIGURE_COMMAND "")
ExternalProject_Get_property(ips4o SOURCE_DIR)
set(ips4o_INCLUDE "${SOURCE_DIR}")

# taywee's C++ args library, header only
ExternalProject_Add(tayweeargs
  GIT_REPOSITORY "https://github.com/Taywee/args.git"
  GIT_TAG "3de44ec671db452cc0c4ef86399b108939768abb"
  UPDATE_COMMAND ""
  INSTALL_COMMAND "")
ExternalProject_Get_property(tayweeargs SOURCE_DIR)
set(tayweeargs_INCLUDE "${SOURCE_DIR}")

ExternalProject_Add(mmap_allocator
  GIT_REPOSITORY "https://github.com/ekg/mmap_allocator.git"
  GIT_TAG "ed61daf094de1c2e1adbe8306287ad52da5f0264"
  BUILD_IN_SOURCE TRUE
  UPDATE_COMMAND ""
  INSTALL_COMMAND ""
  BUILD_COMMAND "make"
  CONFIGURE_COMMAND "")
ExternalProject_Get_property(mmap_allocator SOURCE_DIR)
set(mmap_allocator_INCLUDE "${SOURCE_DIR}")

set(CMAKE_BUILD_TYPE Debug)

# set up our target executable and specify its dependencies and includes
add_executable(iitii
  ${CMAKE_SOURCE_DIR}/src/main.cpp
  )
add_dependencies(iitii ips4o tayweeargs mmap_allocator)
target_include_directories(iitii PUBLIC
  "${CMAKE_SOURCE_DIR}/src"
  "${ips4o_INCLUDE}"
  "${mmap_allocator_INCLUDE}"
  "${tayweeargs_INCLUDE}")

target_link_libraries(iitii
  "${mmap_allocator_INCLUDE}/libmmap_allocator.a"
  "-latomic")
  
if (APPLE)
elseif (TRUE)
  set(CMAKE_EXE_LINKER_FLAGS "-static")
endif()

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
include(ExternalProject)

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

project(iitii)
INCLUDE(ExternalProject)
include_directories(${PROJECT_SOURCE_DIR}/..)

# After build, double-check external/src/htslib-stamp/htslib-build-out.log
# to make sure CFLAGS were set as expected
ExternalProject_Add(htslib
    URL https://github.com/samtools/htslib/releases/download/1.9/htslib-1.9.tar.bz2
    PREFIX ${CMAKE_CURRENT_BINARY_DIR}/external
    CONFIGURE_COMMAND ""
    PATCH_COMMAND sed -i "s/^CFLAGS .*$/CFLAGS = -gdwarf -O3 -DNDEBUG/" Makefile
    BUILD_IN_SOURCE 1
    BUILD_COMMAND bash -c "make -n && make -j$(nproc)"
    INSTALL_COMMAND ""
    LOG_DOWNLOAD ON
    LOG_BUILD ON
  )
ExternalProject_Get_Property(htslib source_dir)
set(HTSLIB_INCLUDE_DIR ${source_dir}/htslib)
include_directories(${HTSLIB_INCLUDE_DIR})
ExternalProject_Get_Property(htslib binary_dir)
add_library(libhts STATIC IMPORTED)
set(LIBHTS_A ${binary_dir}/libhts.a)
set_property(TARGET libhts PROPERTY IMPORTED_LOCATION ${LIBHTS_A})

ExternalProject_Add(CTPL
    URL https://github.com/vit-vit/CTPL/archive/v.0.0.2.zip
    PREFIX ${CMAKE_CURRENT_BINARY_DIR}/external
    CONFIGURE_COMMAND ""
    BUILD_IN_SOURCE 1
    BUILD_COMMAND ""
    INSTALL_COMMAND ""
    LOG_DOWNLOAD ON
  )
ExternalProject_Get_Property(CTPL source_dir)
set(CTPL_INCLUDE_DIR ${source_dir})
include_directories(${CTPL_INCLUDE_DIR})

ExternalProject_Add(catch
  URL https://github.com/philsquared/Catch/archive/v2.9.1.zip
  PREFIX ${CMAKE_CURRENT_BINARY_DIR}/external
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
  LOG_DOWNLOAD ON
  )
ExternalProject_Get_Property(catch source_dir)
include_directories(${source_dir}/single_include)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -std=c++17 -Wall -Werror=return-type -Wno-reorder -fdiagnostics-color=auto")

add_executable(test_iitii util.h test_iitii.cc)
add_dependencies(test_iitii catch libhts)
target_link_libraries(test_iitii libhts libz.a libbz2.a liblzma.a)

add_executable(dumb_benchmark util.h dumb_benchmark.cc)
add_dependencies(dumb_benchmark libhts)
target_link_libraries(dumb_benchmark libhts libz.a libbz2.a liblzma.a)

add_executable(gnomad_benchmark util.h gnomad_benchmark.cc)
add_dependencies(gnomad_benchmark libhts)
target_link_libraries(gnomad_benchmark libhts libz.a libbz2.a liblzma.a)

include(CTest)
add_test(NAME unit_tests COMMAND bash -c "LD_PRELOAD=/usr/lib/x86_64-linux-gnu/libjemalloc.so ./test_iitii -d yes")

=== debian/changelog ===
iitii (0.0+git20191030.85209e0-4) unstable; urgency=medium

  * Fix build with CMake 4
    Closes: #1113005
  * d/watch: version=5
  * Cleanup behind testing + fix clean target
    Closes: #1046269
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)
  * Prevent building on i386 in Salsa CI and tolerate blhc failure

 -- Andreas Tille <tille@debian.org>  Fri, 17 Oct 2025 20:49:50 +0200

iitii (0.0+git20191030.85209e0-3) unstable; urgency=medium

  * Packaging update
  * Standards-Version: 4.7.0 (routine-update)
  * Replace transitional package pkg-config by pkgconf in Build-Depends
    (routine-update)
  * d/copyright: Review thanks to lrc

 -- Andreas Tille <tille@debian.org>  Sat, 14 Dec 2024 18:52:28 +0100

iitii (0.0+git20191030.85209e0-2) unstable; urgency=medium

  * Rules-Requires-Root: no (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 18 Oct 2020 21:01:11 +0200

iitii (0.0+git20191030.85209e0-1) unstable; urgency=medium

  * Initial release (Closes: #962557)

 -- Andreas Tille <tille@debian.org>  Tue, 09 Jun 2020 23:14:23 +0200

=== debian/control ===
Source: iitii
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Andreas Tille <tille@debian.org>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libips4o-dev,
 libargs-dev,
 libmmap-allocator-dev,
 libopenmpi-dev,
 catch2 <!nocheck>,
 pkgconf <!nocheck>,
 libhts-dev <!nocheck>,
 libglib2.0-dev <!nocheck>,
Vcs-Browser: https://salsa.debian.org/med-team/iitii
Vcs-Git: https://salsa.debian.org/med-team/iitii.git
Homepage: https://github.com/ekg/iitii
Rules-Requires-Root: no

Package: iitii
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Implicit Interval Tree with Interpolation Index
 Iitii is a data structure for indexing begin/end position intervals,
 such as genomic feature annotations, and answering requests for all
 items overlapping a query interval. Building on cgranges by Heng Li,
 iitii explores ideas from DBMS interpolation search and learned index
 structures to speed up queries on large datasets.

Package: libiitii-dev
Architecture: all
Section: libdevel
Depends:
 ${misc:Depends},
 libips4o-dev,
 libargs-dev,
 libmmap-allocator-dev,
Description: Implicit Interval Tree with Interpolation Index (devel)
 Iitii is a data structure for indexing begin/end position intervals,
 such as genomic feature annotations, and answering requests for all
 items overlapping a query interval. Building on cgranges by Heng Li,
 iitii explores ideas from DBMS interpolation search and learned index
 structures to speed up queries on large datasets.
 .
 This package contains the header files for development.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

# for hardening you might like to uncomment this:
# export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CMAKE_EXTRA_FLAGS += -DDEBIAN_BUILD=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS) -DCMAKE_POLICY_VERSION_MINIMUM=3.5

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cp $(CURDIR)/debian/missing-sources/htslib/* test
	cp $(CURDIR)/debian/missing-sources/ctpl/*.h test
	cd test && cmake . && make || true
	cd test && \
	rm -rf external CMakeFiles Testing \
	       CMakeCache.txt CTestTestfile.cmake DartConfiguration.tcl \
	       Makefile README cmake_install.cmake ctpl_stl.h h*.h kstring.h t*.h
endif

=== debian/watch ===
Version: 5

Source: https://github.com/ekg/iitii.git
Matching-Pattern: HEAD
Mode: git
Git-Pretty: 0.0+git%cd.%h
